/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex;

/**
 *
 * @author jarek
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.sql.Blob;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class EnhancedBlobDemo {

    Connection con = null;
    
    public EnhancedBlobDemo() {
        try {
            EnvInfoSingleton env = EnvInfoSingleton.INSTANCE;
            con = DriverManager.getConnection(env.getDbURL() 
                    + env.getServerName() + ";trace=" + env.getTrace(), env.getDbUser(), 
                    env.getDbPassword());
        } catch (SQLException e) {
            e.printStackTrace();
        }

    // Now we have a valid connection...
    }

    public static void main(String[] args) {
        EnhancedBlobDemo ebd = new EnhancedBlobDemo();
        ebd.swapPicture();
    }

    private Blob readBlobFromFile(String inputFileName) throws Exception {
        Blob blob = con.createBlob();

        File binFile = new File(inputFileName);
        InputStream bin = new FileInputStream(binFile);
        int availableLength = bin.available();
        byte[] totalBytes = new byte[availableLength];
        int bytedata = bin.read(totalBytes);
        if (bin != null) {
            bin.close();
        }
        blob.setBytes(1, totalBytes);
        return blob;

    }

    private void writeBlobToFile(Blob blob, String outputFileName) throws Exception {
        InputStream in = blob.getBinaryStream();
        File boutFile = new File(outputFileName);
        FileOutputStream bout = new FileOutputStream(boutFile);
        byte[] totalBytes = new byte[(int) blob.length()];
        totalBytes = blob.getBytes(1L, (int) blob.length());
        bout.write(totalBytes);
        if (bout != null) {
            bout.close();
        }
    }

    private void swapPicture() {
        PreparedStatement pstmt = null;
        ResultSet rs = null;
        String query = null;

        try {
            query = "select empno, picture from sample.emp_photo " + 
                    "where empno ='000130' and photo_format = 'gif'";
            pstmt = con.prepareStatement(query, ResultSet.TYPE_FORWARD_ONLY, 
                    ResultSet.CONCUR_UPDATABLE);
            rs = pstmt.executeQuery();
            System.out.println("resultset retrieved");
            while (rs.next()) {
                Blob blob = con.createBlob();
                blob = rs.getBlob(2);
                this.writeBlobToFile(blob, "./OriginalPictureFor" + 
                        rs.getString(1).trim() + ".gif");
                blob = this.readBlobFromFile("./NewPictureFor" + 
                        rs.getString(1).trim() + ".gif");
                rs.updateBlob(2, blob);
                rs.updateRow();
                blob.free();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                rs.close();
                pstmt.close();
                con.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
