/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex;

import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.xpath.*;
import org.w3c.dom.NodeList;

public class XPathTester {

    private Document document;
    private String query;

    public XPathTester(String filename) {
        try {
            InputSource inputSource = new InputSource(filename);
            BufferedReader in = new BufferedReader(new InputStreamReader(
                    System.in));
            do {
                System.out.print("XPath> ");
                query = in.readLine();
                try {
                    XPath xpath = XPathFactory.newInstance().newXPath();
                    NodeList nodes = (NodeList) xpath.evaluate(query,
                            inputSource, XPathConstants.NODESET);
                    if (nodes == null) {
                        System.out.println("XPath query must return a node-set");
                    } else {
                        for (int i = 0; i < nodes.getLength(); i++) {
                            System.out.println("Name: " + nodes.item(i).getNodeName());
                            System.out.println("Value: " + nodes.item(i).getNodeValue());
                        }
                    }
                } catch (XPathExpressionException e) {
                    System.out.println("Invalid XPath query: " + query);
                }
            } while (!(query.equals("quit")));
        } catch (IOException e) {
            System.err.println("Could not load '" + filename + "': " + e.toString());
        }
    }

    public static void main(String[] args) {
        if (args.length == 1) {
            new XPathTester(args[0]);
        } else {
            new XPathTester("./CountryByRegionSales.xml");
            //System.err.println("Usage: java XPathTester <filename>");
        }
    }
} // end of class XPathTester

